// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from micro_ros_diagnostic_msgs:srv/MicroROSSelfTest.idl
// generated code does not contain a copyright notice

#ifndef MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__TRAITS_HPP_
#define MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "micro_ros_diagnostic_msgs/srv/detail/micro_ros_self_test__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const MicroROSSelfTest_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MicroROSSelfTest_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MicroROSSelfTest_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use micro_ros_diagnostic_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  micro_ros_diagnostic_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use micro_ros_diagnostic_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request & msg)
{
  return micro_ros_diagnostic_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>()
{
  return "micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request";
}

template<>
inline const char * name<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>()
{
  return "micro_ros_diagnostic_msgs/srv/MicroROSSelfTest_Request";
}

template<>
struct has_fixed_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'status'
#include "micro_ros_diagnostic_msgs/msg/detail/micro_ros_diagnostic_status__traits.hpp"

namespace micro_ros_diagnostic_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const MicroROSSelfTest_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: passed
  {
    out << "passed: ";
    rosidl_generator_traits::character_value_to_yaml(msg.passed, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    to_flow_style_yaml(msg.status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MicroROSSelfTest_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: passed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "passed: ";
    rosidl_generator_traits::character_value_to_yaml(msg.passed, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status:\n";
    to_block_style_yaml(msg.status, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MicroROSSelfTest_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace micro_ros_diagnostic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use micro_ros_diagnostic_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  micro_ros_diagnostic_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use micro_ros_diagnostic_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response & msg)
{
  return micro_ros_diagnostic_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>()
{
  return "micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response";
}

template<>
inline const char * name<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>()
{
  return "micro_ros_diagnostic_msgs/srv/MicroROSSelfTest_Response";
}

template<>
struct has_fixed_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest>()
{
  return "micro_ros_diagnostic_msgs::srv::MicroROSSelfTest";
}

template<>
inline const char * name<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest>()
{
  return "micro_ros_diagnostic_msgs/srv/MicroROSSelfTest";
}

template<>
struct has_fixed_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest>
  : std::integral_constant<
    bool,
    has_fixed_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>::value &&
    has_fixed_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>::value
  >
{
};

template<>
struct has_bounded_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest>
  : std::integral_constant<
    bool,
    has_bounded_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>::value &&
    has_bounded_size<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>::value
  >
{
};

template<>
struct is_service<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest>
  : std::true_type
{
};

template<>
struct is_service_request<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Request>
  : std::true_type
{
};

template<>
struct is_service_response<micro_ros_diagnostic_msgs::srv::MicroROSSelfTest_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICRO_ROS_DIAGNOSTIC_MSGS__SRV__DETAIL__MICRO_ROS_SELF_TEST__TRAITS_HPP_
