// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from micro_ros_diagnostic_msgs:msg/MicroROSDiagnosticStatus.idl
// generated code does not contain a copyright notice

#ifndef MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__STRUCT_HPP_
#define MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus __attribute__((deprecated))
#else
# define DEPRECATED__micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus __declspec(deprecated)
#endif

namespace micro_ros_diagnostic_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MicroROSDiagnosticStatus_
{
  using Type = MicroROSDiagnosticStatus_<ContainerAllocator>;

  explicit MicroROSDiagnosticStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->level = 0;
      this->updater_id = 0;
      this->hardware_id = 0;
      this->key = 0;
      this->value_type = 0;
      this->bool_value = false;
      this->int_value = 0l;
      this->double_value = 0.0f;
      this->value_id = 0;
    }
  }

  explicit MicroROSDiagnosticStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->level = 0;
      this->updater_id = 0;
      this->hardware_id = 0;
      this->key = 0;
      this->value_type = 0;
      this->bool_value = false;
      this->int_value = 0l;
      this->double_value = 0.0f;
      this->value_id = 0;
    }
  }

  // field types and members
  using _level_type =
    unsigned char;
  _level_type level;
  using _updater_id_type =
    uint16_t;
  _updater_id_type updater_id;
  using _hardware_id_type =
    uint16_t;
  _hardware_id_type hardware_id;
  using _key_type =
    uint16_t;
  _key_type key;
  using _value_type_type =
    unsigned char;
  _value_type_type value_type;
  using _bool_value_type =
    bool;
  _bool_value_type bool_value;
  using _int_value_type =
    int32_t;
  _int_value_type int_value;
  using _double_value_type =
    float;
  _double_value_type double_value;
  using _value_id_type =
    uint16_t;
  _value_id_type value_id;

  // setters for named parameter idiom
  Type & set__level(
    const unsigned char & _arg)
  {
    this->level = _arg;
    return *this;
  }
  Type & set__updater_id(
    const uint16_t & _arg)
  {
    this->updater_id = _arg;
    return *this;
  }
  Type & set__hardware_id(
    const uint16_t & _arg)
  {
    this->hardware_id = _arg;
    return *this;
  }
  Type & set__key(
    const uint16_t & _arg)
  {
    this->key = _arg;
    return *this;
  }
  Type & set__value_type(
    const unsigned char & _arg)
  {
    this->value_type = _arg;
    return *this;
  }
  Type & set__bool_value(
    const bool & _arg)
  {
    this->bool_value = _arg;
    return *this;
  }
  Type & set__int_value(
    const int32_t & _arg)
  {
    this->int_value = _arg;
    return *this;
  }
  Type & set__double_value(
    const float & _arg)
  {
    this->double_value = _arg;
    return *this;
  }
  Type & set__value_id(
    const uint16_t & _arg)
  {
    this->value_id = _arg;
    return *this;
  }

  // constant declarations
  static constexpr unsigned char OK =
    0;
  static constexpr unsigned char WARN =
    1;
  // guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
  static constexpr unsigned char ERROR =
    2;
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif
  static constexpr unsigned char STALE =
    3;
  static constexpr unsigned char VALUE_BOOL =
    1;
  static constexpr unsigned char VALUE_INT =
    2;
  static constexpr unsigned char VALUE_DOUBLE =
    3;
  static constexpr unsigned char VALUE_LOOKUP =
    10;

  // pointer types
  using RawPtr =
    micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus
    std::shared_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus
    std::shared_ptr<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MicroROSDiagnosticStatus_ & other) const
  {
    if (this->level != other.level) {
      return false;
    }
    if (this->updater_id != other.updater_id) {
      return false;
    }
    if (this->hardware_id != other.hardware_id) {
      return false;
    }
    if (this->key != other.key) {
      return false;
    }
    if (this->value_type != other.value_type) {
      return false;
    }
    if (this->bool_value != other.bool_value) {
      return false;
    }
    if (this->int_value != other.int_value) {
      return false;
    }
    if (this->double_value != other.double_value) {
      return false;
    }
    if (this->value_id != other.value_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const MicroROSDiagnosticStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MicroROSDiagnosticStatus_

// alias to use template instance with default allocator
using MicroROSDiagnosticStatus =
  micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::OK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::WARN;
#endif  // __cplusplus < 201703L
// guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::ERROR;
#endif  // __cplusplus < 201703L
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::STALE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::VALUE_BOOL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::VALUE_INT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::VALUE_DOUBLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr unsigned char MicroROSDiagnosticStatus_<ContainerAllocator>::VALUE_LOOKUP;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace micro_ros_diagnostic_msgs

#endif  // MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__STRUCT_HPP_
