// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from micro_ros_diagnostic_msgs:msg/MicroROSDiagnosticStatus.idl
// generated code does not contain a copyright notice

#ifndef MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__TRAITS_HPP_
#define MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "micro_ros_diagnostic_msgs/msg/detail/micro_ros_diagnostic_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace micro_ros_diagnostic_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MicroROSDiagnosticStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: level
  {
    out << "level: ";
    rosidl_generator_traits::character_value_to_yaml(msg.level, out);
    out << ", ";
  }

  // member: updater_id
  {
    out << "updater_id: ";
    rosidl_generator_traits::value_to_yaml(msg.updater_id, out);
    out << ", ";
  }

  // member: hardware_id
  {
    out << "hardware_id: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_id, out);
    out << ", ";
  }

  // member: key
  {
    out << "key: ";
    rosidl_generator_traits::value_to_yaml(msg.key, out);
    out << ", ";
  }

  // member: value_type
  {
    out << "value_type: ";
    rosidl_generator_traits::character_value_to_yaml(msg.value_type, out);
    out << ", ";
  }

  // member: bool_value
  {
    out << "bool_value: ";
    rosidl_generator_traits::value_to_yaml(msg.bool_value, out);
    out << ", ";
  }

  // member: int_value
  {
    out << "int_value: ";
    rosidl_generator_traits::value_to_yaml(msg.int_value, out);
    out << ", ";
  }

  // member: double_value
  {
    out << "double_value: ";
    rosidl_generator_traits::value_to_yaml(msg.double_value, out);
    out << ", ";
  }

  // member: value_id
  {
    out << "value_id: ";
    rosidl_generator_traits::value_to_yaml(msg.value_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MicroROSDiagnosticStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: level
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "level: ";
    rosidl_generator_traits::character_value_to_yaml(msg.level, out);
    out << "\n";
  }

  // member: updater_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "updater_id: ";
    rosidl_generator_traits::value_to_yaml(msg.updater_id, out);
    out << "\n";
  }

  // member: hardware_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hardware_id: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_id, out);
    out << "\n";
  }

  // member: key
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "key: ";
    rosidl_generator_traits::value_to_yaml(msg.key, out);
    out << "\n";
  }

  // member: value_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value_type: ";
    rosidl_generator_traits::character_value_to_yaml(msg.value_type, out);
    out << "\n";
  }

  // member: bool_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bool_value: ";
    rosidl_generator_traits::value_to_yaml(msg.bool_value, out);
    out << "\n";
  }

  // member: int_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "int_value: ";
    rosidl_generator_traits::value_to_yaml(msg.int_value, out);
    out << "\n";
  }

  // member: double_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "double_value: ";
    rosidl_generator_traits::value_to_yaml(msg.double_value, out);
    out << "\n";
  }

  // member: value_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value_id: ";
    rosidl_generator_traits::value_to_yaml(msg.value_id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MicroROSDiagnosticStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace micro_ros_diagnostic_msgs

namespace rosidl_generator_traits
{

[[deprecated("use micro_ros_diagnostic_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  micro_ros_diagnostic_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use micro_ros_diagnostic_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus & msg)
{
  return micro_ros_diagnostic_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus>()
{
  return "micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus";
}

template<>
inline const char * name<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus>()
{
  return "micro_ros_diagnostic_msgs/msg/MicroROSDiagnosticStatus";
}

template<>
struct has_fixed_size<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<micro_ros_diagnostic_msgs::msg::MicroROSDiagnosticStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICRO_ROS_DIAGNOSTIC_MSGS__MSG__DETAIL__MICRO_ROS_DIAGNOSTIC_STATUS__TRAITS_HPP_
